100 INPUT "Drive number ";d
110 IF d<1 OR d>8 THEN GO TO 100
120 DIM z$(250,13): DIM n$(13)
130 *D d: *L d
135 PRINT "Wait a sec ..."
139 REM find last item
140 FOR i=1 TO 250
150 IF Z$(i,12)<>CHR$ 255 THEN NEXT i
160 LET n=i-1
169 REM ove repetitions
170 FOR i=2 TO n
180 IF z$(i, TO 12)<>z$(i-1, TO 12) THEN GO TO 190
182 IF CODE z$(i,13)>127 THEN LET z$(i)=n$: GO TO 190
184 LET z$(i-1)=n$
190 NEXT i
200 LET c=2
1000 CLS: PRINT INVERSE 1;"      MICRODRIVE REPAIR KIT     "
1005 PRINT ''"0. Output to ";"printer" AND c=2;"screen" AND c=3
1010 PRINT '"1. Full catalogue"
1020 PRINT '"2. Sector list"
1030 PRINT '"3. Bad sector list"
1040 PRINT '"4. Check file"
1050 PRINT '"5. Examine sector"
1060 PRINT '"6. Repair sector"
1070 PRINT '"7. Remove sector"
1080 PRINT '"8. Change drive no."
1090 PRINT
1095 INPUT ;: PRINT #0;"Choose an option";
1100 PAUSE 0: LET a$=INKEY$: INPUT ;
1110 IF a$<"0" OR a$>"8" THEN GO TO 1095
1120 IF a$="0" THEN LET c=5-c: GO TO 1000
1125 IF a$="8" THEN INPUT "Drive no.";d:*D d: GO TO 1000
1130 GO SUB 1000+1000*VAL a$
1140 IF c=2 THEN PRINT "Press any key for menu": PAUSE 0
1150 GO TO 1000
1999 REM Full catalogue
2000 PRINT #c;"Full catalogue"
2010 DIM f$(10): LET f$=z$(1)
2020 FOR i=1 TO n
2030 IF z$(i)=n$ OR z$(i, TO 10)=f$ THEN GO TO 2060
2040 PRINT #c;f$( TO 10)
2050 LET f$=z$(i, TO 10)
2060 NEXT i
2065 PRINT #c;z$(n, TO 10)
2070 RETURN
2999 REM Complete sector list
3000 DIM f$(10): INPUT "Filename (or ENTER for all):",f$
3010 FOR i=1 TO n
3015 IF z$(i)=n$ THEN GO TO 3030
3020 IF f$=n$( TO 10) THEN GO SUB 9500: GO TO 3030
3025 IF z$(i, TO 10)=f$ THEN GO SUB 9500
3030 NEXT i
3040 RETURN
3999 REM Bad sector list
4000 PRINT #c;"Bad sector list"
4010 FOR i=1 TO n
4020 IF z$(i)<>n$ AND z$(i,13)>CHR$ 127 THEN GO SUB 9500
4030 NEXT i
4040 RETURN
4999 REM Check file
5000 DIM f$(10): INPUT "Filename? ";f$
5005 DIM x$(256): LET eof=-1: LET good=1
5010 FOR i=1 TO n
5020 IF z$(i, TO 10)<>f$ THEN GO TO 5100
5030 IF z$(i,13)>CHR$ 127 THEN GO TO 5060
5039 REM good sector
5040 LET x$(CODE z$(i,11)+1)="y"
5050 GO TO 5080
5059 REM bad sector
5060 PRINT #c;"Record ";CODE z$(i,11);" bad on sector ";CODE z$(i,12)
5070 LET good=0
5080 LET a=CODE z$(i,13)
5090 IF a/2<>INT (a/2) THEN LET eof=CODE z$(i,11)
5100 NEXT i
5110 IF eof>=0 THEN GO TO 5120
5111 REM missing EOF
5112 FOR i=250 TO 1 STEP -1
5114 IF x$(i)=" " THEN NEXT i
5116 LET eof=i-1
5118 LET good=0: PRINT #c;"No EOF record"
5120 FOR i=0 TO eof
5130 IF x$(i+1)=" " THEN PRINT "Record ";i;" missing": LET good=0
5140 NEXT i
5150 IF good=1 THEN PRINT "File ";f$;" intact"
5160 IF good=0 THEN PRINT "File ";f$;" corrupted"
5170 RETURN
5999 REM Read a sector
6000 INPUT "Sector no.";s
6010 *F s CODE 60000
6020 IF c=2 THEN CLS
6090 PRINT #c;"Sector ";s
6100 IF PEEK 60000 THEN PRINT #c; FLASH 1;"Not found": RETURN
6110 PRINT #c;"Cart name:";
6120 FOR i=44 TO 53
6130 PRINT #c;CHR$ PEEK (60000+i);
6140 NEXT i: PRINT #c
6150 PRINT #c;"RECFLG:";PEEK 60067
6160 PRINT #c;"RECNUM:";PEEK 60068
6170 PRINT #c;"RECLEN:";PEEK 60069+256*PEEK 60070
6180 PRINT #c;"Filename:";
6190 FOR i=71 TO 80
6200 PRINT #c;CHR$ PEEK (60000+i);
6210 NEXT i: PRINT #c
6220 PRINT #c;"Checksum1:";PEEK 60081,
6230 IF PEEK 60011=PEEK 60081 THEN PRINT #c;"OK"
6240 IF PEEK 60011<>PEEK 60081 THEN PRINT #c;"(should be ";PEEK 60011;")"
6245 PRINT #c;"Checksum2:";PEEK 60594,
6250 IF PEEK 60012=PEEK 60594 THEN PRINT #c;"OK"
6260 IF PEEK 60012<>PEEK 60594 THEN PRINT #c;"(should be ";PEEK 60012;")"
6300 RETURN
6999 REM repair sector
7000 GO SUB 6000
7010 IF PEEK 60000 THEN RETURN
7020 PRINT '"Re-writing to spare sector"
7030 *S CODE 60000
7040 PRINT
7050 RETURN
7999 REM remove sector
8000 INPUT "Sector no.";s
8010 *E s
8020 PRINT "Sector removed"
8030 RETURN
9000 CLEAR 32815: LOAD *"m";1;"SLC.3" CODE: RANDOMIZE USR 32816: RUN
9500 PRINT #c;z$(i, TO 10);" r";CODE z$(i,11);TAB 16;"s";CODE z$(i,12);TAB 21;
9510 LET f=CODE z$(i,13)
9520 IF f/2<>INT (f/2) THEN PRINT #c;"EOF";
9530 IF CODE z$(i,13)>127 THEN PRINT #c;TAB 25;"BAD";
9540 PRINT #c
9550 RETURN
9999 CLEAR: ERASE "m";1;"repair 2": SAVE *"m";1;"repair 2"
